<?php

namespace CreoCode\ContaoPhotoswipe\Listener;

use Contao\File;

/**
 * Class Hooks
 */
class Hooks {

    /**
     * Disable libxml errors
     */
    public function __construct() {
        libxml_use_internal_errors(true);
    }
    
    /**
     * Enable libxml errors
     */
    public function __destruct() {
        libxml_use_internal_errors(false);
    }

    /**
     * Inject data-size attribute
     */
    public function getContentElement($objTemplate, $strBuffer) {

        if(empty($strBuffer)) {
            return $strBuffer;
        }

        $dom = new \DOMDocument();
        $dom->loadXML($strBuffer);
        $xPath = new \DOMXpath($dom);
        $linksFound = false;
        foreach($xPath->query('//a[@data-lightbox]') as $link) {
            if ($link->getAttribute('href') && $link->getAttribute('data-lightbox')) {
                $objFile = new File($link->getAttribute('href'));
                $link->setAttribute('data-size', implode('x', $objFile->imageViewSize));
                $linksFound = true;
            }
        }

        // If Links found return injected html else return buffer
        if ($linksFound) {
            return $dom->saveXML($dom->documentElement, LIBXML_NOEMPTYTAG);
        } else {
            return $strBuffer;
        }
        
    }
}